
        class Utility
        {

            static create() {
                Node.prototype.add = function(tag, cnt, txt) {
                        for (var i = 0; i < cnt; i++)
                                this.appendChild(Utility.ce(tag, txt));
                }
                Node.prototype.ins = function(tag) {
                        this.insertBefore(Utility.ce(tag), this.firstChild)
                }
                Node.prototype.kid = function(i) { return this.childNodes[i]; }
                Node.prototype.cls = function(t) { this.className += ' ' + t; }

                NodeList.prototype.map = function(g) {
                        for (var i = 0; i < this.length; i++) g(this[i]);
                }
            }
        
            static gid(e) {
                return document.getElementById(e);

            }

            static ce(tag, txt) {
                var x = document.createElement(tag);
                if (txt !== undefined) x.innerHTML = txt;
                return x;
            }

            static irand(x) {
                return Math.floor(Math.random() * x);

            }
        
            static getCharFromInt(from, to) {
                const char = new Array();
                var j = 0;

                for(let i = from; i < to; i++) {
                    char[j++] = String.fromCharCode(i);

                }

                return char;   
            
            }
            
            static toChar(ch) {
                let chFInt = Utility.getCharFromInt(65, 65 + ch);
                return chFInt[ch-1];
                
            }
            
            static getIndex(td) {
                if(td === null) 
                    return [1,1];

                let classes = td.className.split(' '),
                        index;
                classes.forEach(function(i) {
                    if(i.startsWith('i')) {
                        index = i.replace('i','').split('-');
                        for(var i = 0; i < index.length; i++) 
                            index[i] = parseInt(index[i], 10);
                    }
                });
                return index;
            }
        }
        
        class Maze
        {

            constructor(obt, width, height, steps = 4) {
                Utility.create();
                steps++;
                this.dirs = ['s', 'e', 'w', 'n'];
                this.width = width;
                this.height = height;
                this.obt = obt;
                this._successText = 'Zvládl jsi to bezvadně!';
                this._wrongInputText = 'Nejdřív musíš vybrat předchozí směr.';
                this._failureText = 'Takhle to asi nebude.';
                let stepRemoveObj = (step) => { this.stepRemove(step); };
                let stepRemoveHandler = stepRemoveObj.bind(this);
                Utility.gid('sol_' + this.obt).style.display = 'block';
                
                do {
                    this.mazeTable = Utility.ce('table');
                    this.mazeTable.id = 'maze';
                    let cnt = Utility.gid('content_' + this.obt);
                    cnt.innerHTML = '';
                    cnt.appendChild(this.mazeTable);
                    this.totalSteps = 0;
                    this.steps = 1;
                    this.mazeStepMap = [...Array(width)].map(() => Array(height));
                    this.makeMaze();
                    this.solve();
                    this.countSteps();

                } while(steps !== this.steps && steps !== 0);
                Utility.gid('loading_'+obt).style.display = 'none';
                this.createCoInputs();
                this.userInputManager = new UserInputManager(this.obt, steps-1, stepRemoveHandler, this.coInputs, width, height);
            }

            makeMaze() {
                const w = this.width;
                this.mazeTable.innerHTML = '';
                this.mazeTable.add('tr', this.height); // vytvoří tabulku o velikost w a h (mapování je řádek)
                this.mazeTable.childNodes.map(function(x) { 
                                x.add('th', 1);
                                x.add('td', w, '*');
                                x.add('th', 1);
                            });
                this.mazeTable.ins('tr');
                this.mazeTable.add('tr', 1);
                this.mazeTable.firstChild.add('th', w + 2);
                this.mazeTable.lastChild.add('th', w + 2); // vložení 1 řádku na začátek a konec tabulky
                for (let i = 1; i <= this.height; i++) { // namapování celé tabulky, kdy jsou u každé buňky tabulky uloženy její sousední buňky
                    for (let j = 1; j <= w; j++) { // procházení řádku
                        this.mazeTable.childNodes[i].childNodes[j].cls('i' + i + '-' + j);
                        this.mazeTable.childNodes[i].childNodes[j].neighbors = [
                                this.mazeTable.kid(i + 1).kid(j), // sousední buňka pod 
                                this.mazeTable.kid(i).kid(j + 1), // sousední buňka napravo 
                                this.mazeTable.kid(i).kid(j - 1),
                                this.mazeTable.kid(i - 1).kid(j)
                        ];
                    }
                }
                this.walk(this.mazeTable.kid(Utility.irand(this.height) + 1).kid(Utility.irand(w) + 1)); // generování bludiště, parametrem je náhodně vybraná buňka -> seed
                this.createLabel();

            }

            shuffle(x) {
                for (var i = 3; i > 0; i--) {
                        let j = Utility.irand(i + 1);
                        if (j === i) continue;
                        let t = x[j]; 
                        x[j] = x[i];
                        x[i] = t;
                }
                return x;

            }

            walk(c) {
                c.innerHTML = '&nbsp;'; // buňka se "stane" součástí bludiště

                let idx = this.shuffle([0, 1, 2, 3]); // náhodný soused
                for (var j = 0; j < 4; j++) {
                    let i = idx[j];
                    let x = c.neighbors[i];
                    if (x.textContent !== '*') continue; // vybere se další soused, pokud je tento již součástí bludiště
                    c.cls(this.dirs[i]); // přidáme oběma buňkám bordery (resp. směr)
                    x.cls(this.dirs[3 - i]); 
                    this.walk(x);
                }
            }

            solve(c = -1, t = -1) {
                if (c === -1) {
                        c = this.mazeTable.kid(2).kid(2);
                        c.cls('v');
                }
                if (t === -1)
                        t = this.mazeTable.lastChild.previousSibling
                                        .lastChild.previousSibling;

                if (c === t) return 1;

                c.vis = 1;
                for (let i = 0; i < 4; i++) {
                        let x = c.neighbors[i];
                        if (x.tagName.toLowerCase() === 'th') continue;
                        if (x.vis || !c.className.match(this.dirs[i]) || !this.solve(x, t))
                                continue;
                        this.totalSteps++;
                        let id = Utility.getIndex(x);
                        this.mazeStepMap[(id[0]-1)][(id[1]-1)] = this.totalSteps;
                        x.cls('v' + ' step' + this.totalSteps);
                        x.setAttribute('data-step', this.totalSteps);
                        return 1;
                }
                c.vis = null;
                return 0;
            }
            
            checkUserSolution() {
                let wrong = false, ls, lsc;
                for(let i = 1; i < this.steps; i++) {
                    if(!this.coInputs[i].correct) {
                        wrong = true;
                        //TextRenderer.render(this._failureText);
                        print_modal('modal','chyba');
                        ls = 1;
                        lsc = [this.width, this.height];
                        if(this.coInputs[i-1] !== undefined) {
                            ls = this.mazeStepMap[this.coInputs[i-1].elY.value][this.coInputs[i-1].elX.value] || 1;
                            lsc = [parseInt(this.coInputs[i-1].elX.value)+1, parseInt(this.coInputs[i-1].elY.value)+1];
                        }                        
                        break;                        
                    }
                }
                this.resetPath();
                if(wrong) {
                    for(let i = 1; i < this.steps; i++) {
                        if(!this.coInputs[i].correct) {
                            this.draw([parseInt(this.coInputs[i].elY.value),parseInt(this.coInputs[i].elX.value)], false, true, ls, lsc);                       
                        } else {
                            this.draw(this.mazeStepMap[this.coInputs[i].elY.value][this.coInputs[i].elX.value], false);    
                        }
                    }
                    
                } else {
                    this.draw();
                    //TextRenderer.render(this._successText);
                    print_modal('modal','ok');
                }
                
            }

            countSteps() {
                this.mazeTable.kid(2).kid(2).cls('step' + (++this.totalSteps));
                this.mazeTable.kid(2).kid(2).setAttribute('data-step', this.totalSteps);
                let steps = new Array(),
                        previousStepId,
                        nextStep;

                steps[1] = document.querySelector('.step'+1);
                for(let i = 1; i <= this.totalSteps; i++) {
                    let stepId = Utility.getIndex(steps[i]);
                    nextStep = document.querySelector('.step'+(i+1));
                    previousStepId = Utility.getIndex(document.querySelector('.step'+(i-1)));
                    let nextStepId;
                    if(nextStep !== null)
                        nextStepId = Utility.getIndex(nextStep);

                    else 
                        nextStepId = [1,1];
                    steps[i+1] = nextStep;

                    steps[i].className += " rl"+this.steps;
                    //dopsani znaku 
                    if(this.steps==1)
                        steps[i].innerHTML = "S";
                    else if(i==this.totalSteps) 
                        steps[i].innerHTML = "C";
                    
                    if(this.matchDir(stepId, nextStepId, previousStepId)) 
                        continue;
                        
                    this.steps++;
                    
                }

            }

            matchDir(dirId, nId, pId) {            
                if(dirId[0] === nId[0] && nId[0] === pId[0]) 
                    return true;

                else if(dirId[1] === nId[1] && nId[1]  === pId[1])
                    return true;

                return false;

            }


            createLabel() {
                this.mazeTable.ins('tr');
                let headRow = this.mazeTable.firstChild;
                headRow.className = "head";
                headRow.appendChild(Utility.ce('td'));
                const labelChars = Utility.getCharFromInt(65, 65 + this.width);

                for (let i = 0; i < this.width; i++)
                    headRow.appendChild(Utility.ce('td', labelChars[i]));

                let mazeRows = this.mazeTable.childNodes;
                for (let i = 2; i < mazeRows.length-1; i++) {
                    mazeRows[i].ins('td');
                    mazeRows[i].firstChild.textContent = i - 1;
                }
            }

            createCoInputs() {
                this.coInputs = new Array();
                let uss = (realX, realY, userX, userY, id) => { this.userSolutionStep(realX, realY, userX, userY, id); };
                let ussHandler = uss.bind(this);
                let lastCell = this.steps-1;
                const separator = 4;
                let prevId = [7, 7];
                let tplIdFirst = [0, 0];    
                let stepF = null;
                let tplIdLast = [0, 0];
                let stepL = null;
                for (let i = 1; i < lastCell; i++) { 
                    let step = document.querySelector('.rl'+(i+1));
                    //let step;
                    let steps = document.querySelectorAll('.rl'+(i+1));
                    if(steps.length > 1){
                        //vyberu spravnou bunku
                        tplIdFirst = Utility.getIndex(steps[0]);
                        tplIdLast = Utility.getIndex(steps[steps.length-1]);
                        stepF = parseInt(steps[0].dataset['step']);
                        stepL = parseInt(steps[steps.length-1].dataset['step']);
                        if (stepF < stepL) step = steps[steps.length - 1];
                        else step = steps[0];                                          
                    }else
                        step = steps[0];
                    let id = Utility.getIndex(step); 
                    prevId = [id[0],id[1]];           
                    this.coInputs[i] = new CoordinatesInput(id[1], id[0], this.width, this.height, 'coInputs_' + this.obt, 'Ověřit', i, ussHandler);
                    if((i+1)%separator === 0) {
                        let br = Utility.ce('br');
                        document.getElementById('coInputs_' + this.obt).appendChild(br);
                    }
                }

                this.coInputs[this.steps - 1] = new CoordinatesInput(1, 1, this.width, this.height, 'coInputs_' + this.obt, 'Ověřit', lastCell, ussHandler);

            }

            userSolutionStep(realX, realY, userX, userY, id) {
                if(this.coInputs[id-1] !== undefined && !this.coInputs[id-1].selected) { // ověřujeme, zda zadává souřadnice postupně
                    this.coInputs[id].selected = false;
                    //TextRenderer.render(this._wrongInputText);
                    print_modal('modal','chyba');
                    return;
                    
                }
                let uX =  parseInt(userX);
                let uY =  parseInt(userY);
                
                this.coInputs[id].lock();                
                this.userInputManager.addStep(id, uX, uY); // přidáme krok do tabulky
                
                if((--realX) === uX && (--realY) === parseInt(userY)) { // pokud se zadaná souřadnice shoduje
                    this.coInputs[id].correct = true;
                    if(this.coInputs[id-1] === undefined || this.coInputs[id-1].correct) { // ověřujeme, zda je předchozí souřadnice správná
                        this.drawGreen(this.mazeStepMap[realY][realX]);

                        if(realX === 0 && realY === 0) {
                            //TextRenderer.render(this._successText);
                            print_modal('modal','ok');
                        }
                        
                    }

                } else {
                    this.coInputs[id].correct = false;
                    
                }

                for(let i = id + 1; i < (this.steps-1); i++) { // projíždíme každý krok, pokud nastala oprava, aby se vše dobarvilo jak má
                    if(this.coInputs[i].correct) {        
                        this.drawGreen(this.mazeStepMap[this.coInputs[i].coY-1][this.coInputs[i].coX-1]); 
                        
                    } else {
                        break;
                        
                    }
                }
                
                if(this.coInputs[this.steps-1].selected && !this.coInputs[this.steps-1].correct) { // pokud zadal všechny souřadnice a řešení je špatné
                    //TextRenderer.render(this._failureText);
                    print_modal('modal','chyba');
                }
                
            }
            
            stepRemove(step) {
                this.coInputs[step].correct = false;
                this.coInputs[step].selected = false;
                this.coInputs[step].unlock();
            }

            resetPath(){
                var elms = document.querySelectorAll("#maze td[style]");
                for (let i = 0; i < elms.length; i++)
                    elms[i].removeAttribute("style");
            }

            draw(to, correct = true, noStep = false, lastCorrect = 0) {
                let color = correct ? '#3ff2f2' : '#ffee59';
                if(correct) {
                    if(to === undefined) to = this.totalSteps;
                    for(let i = 2; i < to; i++) {
                        document.querySelector('.step'+i).style.background = color;
                    }
                } else if(!correct && noStep) {
                    for(let i = 2; i <= lastCorrect; i++) {
                        document.querySelector('.step'+i).style.background = color;
                    }
                    document.querySelector('.i'+(to[0]+1)+'-'+(to[1]+1)).style.background = color;
                } 
            }

            destroy() {
                this.mazeTable.remove();
                this.coInputs.forEach(function(inp) {
                    inp.destroy();
                });
                this.userInputManager.destroy();
                Utility.gid('sol_' + this.obt).style.display = 'none';
            }
            /*
            set successText(successText) {
                this._successText = successText;
            }

            set wrongInputText(wrongInputText) {
                this._wrongInputText = wrongInputText;
            }

            set failureTextText(failureText) {
                this._failureText = failureText;
            }
            */
        }

        class CoordinatesInput
        {

            constructor(corrX, corrY, sizeX, sizeY, htmlId, sendButtonText, id, update) {
                this.valueX = corrX;
                this.valueY = corrY;
                this.sizeX = sizeX;
                this.sizeY = sizeY;
                this.updateCallback = update;
                this.htmlId = htmlId;
                this.sendButtonText = sendButtonText;
                this._correct = false;
                this.id = id;
                this.build();

            }

            build() {
                this.elementX = Utility.ce('select');
                const chars = Utility.getCharFromInt(65, 65 + this.sizeX);

                for (let i = 0; i < this.sizeX; i++) {                     
                    this.fillSelect(this.elementX, i, chars[i]);
                }

                this.elementY = Utility.ce('select');
                for (let i = 0; i < this.sizeY; i++) {
                     this.fillSelect(this.elementY, i, i+1);
                }

                this.clickedEvent = () => {
                    this.update();
                };
                this.checkHandler = () => {
                    this.check();
                }

                this.checkCHandler = this.checkHandler.bind(this);
                if(this.valueX === parseInt(this.elementX.value)+1 && this.valueY === parseInt(this.elementY.value)+1)
                    this._correct = true;
                this.clickedHandler = this.clickedEvent.bind(this);
                this.elementX.addEventListener('click', this.checkCHandler);
                this.elementY.addEventListener('click', this.checkCHandler);
                this.sendButton = Utility.ce('button');
                this.sendButton.addEventListener('click', this.clickedHandler);
               
                this.sendButton.innerText = this.sendButtonText;
                let doc = document.getElementById(this.htmlId);
                doc.appendChild(this.elementX);
                doc.appendChild(this.elementY);
                //doc.appendChild(this.sendButton);

            }
            check() {
                if(this.valueX === parseInt(this.elementX.value)+1 && this.valueY === parseInt(this.elementY.value)+1) 
                    this._correct = true;              
                else
                    this._correct = false;
            }
            
            get elX() {
                return this.elementX;               
            }
            get elY() {
                return this.elementY;                
            }

            update() { 
                this._selected = true;
                this.updateCallback(this.valueX, this.valueY, this.elementX.value, this.elementY.value, this.id);
               // this.lock();

            }        

            destroy() {
                this.sendButton.remove();
                this.elementX.remove();
                this.elementY.remove();

            }

            lock() {
                this.sendButton.disabled = true;
                this.elementX.disabled = true;
                this.elementY.disabled = true;
            }

            unlock() {
                this.sendButton.disabled = false;
                this.elementX.disabled = false;
                this.elementY.disabled = false;
            }

            fillSelect(sel, value, text) {
                let option = Utility.ce('option');
                option.value = value;
                option.text = text;
                sel.add(option);  
            }
            
            get selected() {
                return this._selected;
            }

            set selected(s) {
                this._selected = s;
            }

            get correct() {
                return this._correct;
            }

            set correct(c) {
                this._correct = c;
            }

            get coX() {
                return this.valueX;
            }
            
            get coY() {
                return this.valueY;
            }

        }

        class UserInputManager
        {

            constructor(obt, inputsCount, stepRemoveCallback, inputs, sizeX, sizeY, colText = ['Krok', 'Souřadnice 1', 'Souřadnice 2'])
            {
                let i = 0;
                //let i = inputsCount+1;
                this.obt = obt;
                this.stepRemoveCb = stepRemoveCallback;
                this.colText = colText;
                this.userManagerElement = Utility.ce('table');
                this.userManagerElement.id = 'user-input';
                this.userManagerElement.add('tr', inputsCount);
                
                this.userManagerElement.childNodes.map(function(x) { 
                                x.add('td', 1, ++i);  
                                x.appendChild(Utility.ce('td')).appendChild(inputs[i].elX);
                                x.appendChild(Utility.ce('td')).appendChild(inputs[i].elY);
                            });
                
                this.userManagerElement.ins('tr');
                let firstCoX = Utility.ce("select");
                let firstCoY = Utility.ce("select");
                let firstCoXOption = Utility.ce("option");
                let firstCoYOption = Utility.ce("option");
                firstCoX.disabled = true;
                firstCoY.disabled = true;
                let ch = Utility.getCharFromInt(65, 65 + sizeX);
                firstCoXOption.innerText = ch[ch.length-1];
                firstCoYOption.innerText = sizeY;
                firstCoX.appendChild(firstCoXOption);
                firstCoY.appendChild(firstCoYOption);
                let secondRow = this.userManagerElement.querySelector("tr:nth-child(1)");
                secondRow.add('td',1,0);    
                secondRow.appendChild(Utility.ce('td')).appendChild(firstCoX);
                secondRow.appendChild(Utility.ce('td')).appendChild(firstCoY);   
                
                this.userManagerElement.ins('tr');
                for (let i = 0; i < this.colText.length; i++)
                    this.userManagerElement.firstChild.appendChild(Utility.ce('td', this.colText[i]));                  

                let lc = this.userManagerElement.lastChild;
                lc.className = 'lastcell';
                let fc = this.userManagerElement.querySelector("tr:nth-child(2)");
                fc.className = 'firstcell';
                Utility.gid('userInputs_' + this.obt).appendChild(this.userManagerElement);         
            }
                 
            addStep(step, valueX, valueY) {
                let el = this.userManagerElement.childNodes[step];
                if(step === null) {
                    throw "Tento krok neexistuje.";
                }

                let clickEvent = () => { this.removeStep(step); };
                this.clickRemoveHandler = clickEvent.bind(this);
                //el.childNodes[1].textContent = Utility.toChar(valueX+1);
                //el.childNodes[2].textContent = valueY+1;
                el.childNodes[3].textContent = '\u2715';
                el.childNodes[3].addEventListener('click', this.clickRemoveHandler);
            }
            
            removeStep(step) {
                let el = this.userManagerElement.childNodes[step];
                el.childNodes[3].removeEventListener("click", this.clickRemoveHandler);
                el.childNodes[3].textContent = '';
                this.stepRemoveCb(step);
                
            }
            
            destroy() {
                this.userManagerElement.remove();
            }

        }

        class TextRenderer
        {

            static render(text) {
                if(text instanceof Array) {
                    text = Utility.irand(text.length);

                }

                setTimeout(() => alert(text),1000);
            }

        }

        var m;
        const wrongInputText = 'Nejdříve musíš vybrat předcházející směr.';
        const successText = [ 'Zvládl jsi to bezvadně!',
            'Dobře ty!',
            'Uhodil si hřebík na hlavičku!',
            'Skvělá práce!',
            'Výborně!' ];
        
        const failureText = [
            'Takhle to být nemá.',
            'Zkus to ještě jednou.',
            'Tohle nebude správné řešení.',
            'Nope, takhle to nemá být.'
        ];
        const difficulty = {
            veryEasy: {
                width: 5,
                height: 5,
                steps: 3
            },
            easy: {
                width: 7,
                height: 7,
                steps: 5   
            },
            medium: {
                width: 10,
                height: 10,
                steps: 7
            },
            hard: {
                width: 13,
                height: 13,
                steps: 12
            },           
        };

        function init(obt) {
            let dif;
            switch(Utility.gid('dif_'+obt).value) {
                case "veryEasy":
                    dif = difficulty.veryEasy;
                    break;
                 case "easy":
                    dif = difficulty.easy;
                    break;
                case "medium":
                    dif = difficulty.medium;
                    break;
                case "hard":
                    dif = difficulty.hard;
                    break;                    
            }

            Utility.gid('loading_'+obt).style.display = 'inline';
            if (m instanceof Maze) {
                m.destroy();
            }
            setTimeout(() => createMaze(obt, dif.width, dif.height, dif.steps), 10);
        }

        function createMaze(obt, w, h, s) {
            m = new Maze(obt,w, h, s);
        }